#include<stdio.h>

#define NIL   0
#define TRUE  1
#define FALSE 0

typedef enum{
     pl0null,pl0odd,pl0times,pl0div,pl0plus,pl0minus,pl0eql,
     pl0neq,  pl0lss, pl0leq, pl0gtr, pl0geq, pl0comma, pl0rparen,
     pl0then, pl0do, pl0lparen, pl0becomes, pl0number, pl0ident,
     pl0semicolon, pl0end,pl0call, pl0if,pl0while,pl0begin,pl0read,
     pl0write,pl0const,pl0var,pl0procedure,pl0period,pl0eof
}Symbol;


extern Symbol        sym;
extern unsigned int     id;
extern unsigned int     num;
extern FILE          *source;
extern int           line;


typedef enum{
   Const, Var, Proc, Header
}ObjectClass;

typedef struct Object *ObjPtr;

typedef struct Object{
   unsigned int    name;
   ObjPtr          next;
   ObjectClass     kind;
   int val;
   unsigned int vlev,vadr;
   unsigned int plev,padr;
   ObjPtr         last,down;
}Object;

static ObjPtr     topScope,undef, bottom;
unsigned int curlev;  

int                  noerr;
unsigned int tempadr;

static err(n)
   int n;
{
   static char *errmsg[] = {
      "",
      " :=ΤȤ=ĤĤƤ",
      "=ΤĤ˸¤Ƥ",
      "̾ΤĤ=ǤʤФʤʤ",
      "CONST, VAR, PROCEDURE ΤĤ̾˸¤Ƥ",
      "; (ޤ ,)ʤ",
      "Ϥ뵭椬äƤ",
      "Ĥ̤ʤ",
      "Ǥ򽪤̤ʤ",
      ".ɬפǤ",
      "ʸ˸ä椬줿", 
      "̾Ƥʤ",
      "̾³̾ˤǤʤ",
      "ˤ:=ȤʤФʤʤ",
      "CALLμ̾ǤʤФʤʤ",
      "̾ѿ̾ФƤӽФϤǤʤ",
      "THENɬפǤ",
      "; ޤ ENDɬפǤ",
      "DOɬפǤ",
      "ʸμ˸ä椬Ƥ",
      "ӱ黻ҤɬפǤ",
      "ˤϼ³̾ϻȤʤ",
      "", "", "",
      "̾ϰ٤Ǥʤ",
      "", "", "","",
      "ͤ礭᤮",
    }; 
  
printf("err\n");
 
    noerr = FALSE;
    printf("  %d    : %s\n",line,errmsg[n]);
    exit(1);  
}

static test(s,n)
   Symbol s; unsigned int n;
{
   if(sym < s){
       err(n);
       printf("err(n) = %d",n);
      do{
         GetSym();
     } while(sym < s);
   }
}

static ObjPtr NewObj(k)
   ObjectClass k;
{
   ObjPtr obj;
   obj = topScope->next;
   while(obj != NIL){
      if(Diff(id,obj->name) == 0)
         err(25);
      obj = obj->next;
   }
   obj = (ObjPtr) malloc(sizeof(Object));
   obj->name = id;
   obj->kind = k;
   obj->next = NIL;

   KeepId();
   topScope->last->next = obj;
   topScope->last = obj;
   return obj;
}

static ObjPtr find(id)
   unsigned int id;
{
   ObjPtr hd,obj;


   hd = topScope;
   while(hd != NIL){
      obj = hd->next;
      while(obj != NIL){
        if(Diff(id,obj->name) == 0)
            return obj;
        else
           obj = obj->next;
      }
      hd = hd->down;
    }
    err(11);
    return undef;
}


static factor()
{
   ObjPtr obj;

   test(pl0lparen,6);
   if(sym == pl0ident) {
      obj = find(id); 
  
      switch(obj->kind){
        case Const : Gen(0,0,obj->val); break;
        case Var   : Gen(2,curlev - (obj->vlev),obj->vadr); break;
        case Proc  :err(21); break;
      }   
   GetSym();
   } 
   else if(sym == pl0number){
       Gen(0,0,num);
       GetSym();
   }
   else if(sym == pl0lparen){
       GetSym();
       expression();
       if(sym == pl0rparen) 
          GetSym();
       else
          err(7);
    }
    else
       err(8);
}

static term()
{   
   Symbol mulop;
   factor();
   while(sym == pl0times || sym == pl0div) {
      mulop = sym;
      GetSym();
      factor();
      if(mulop == pl0times)
        Gen(1,0,4);
      else
        Gen(1,0,5);
   }
}

static expression()
{  
    Symbol addop;
    if (sym == pl0plus || sym == pl0minus){
        addop = sym;
        GetSym();
        term();
        if(addop == pl0minus)
           Gen(1,0,1);
    }
    else
       term();
    while(sym == pl0plus || sym == pl0minus) {
       addop = sym;
       GetSym();
       term();
       if(addop == pl0plus)
          Gen(1,0,2);
       else
          Gen(1,0,3);
    }
}

static condition()
{ 
    Symbol relop;
    if(sym == pl0odd) {
       GetSym();
       expression();
       Gen(1,0,6);
    }
    else{
       expression();
       if(pl0eql <= sym && sym <= pl0geq) {
          relop = sym;
          GetSym();
          expression();
          switch(relop){
             case pl0eql : Gen(1,0,8);  break;
             case pl0neq : Gen(1,0,9);  break;
             case pl0lss : Gen(1,0,10); break;
             case pl0geq : Gen(1,0,11); break;
             case pl0gtr : Gen(1,0,12); break;
             case pl0leq : Gen(1,0,13); break;
          }
       }
       else
         err(20);
    }
}

static statement()
{
   ObjPtr obj;
   unsigned int L0,L1;


   test(pl0ident,10);

  if(sym == pl0ident) {
      obj = find(id);
      if(obj->kind != Var){
          err(12);
          obj = NIL;
      }
      GetSym();
 
      if(sym == pl0becomes)
         GetSym();
      else if(sym == pl0eql){
         err(13);
         GetSym();
      }
      else
         err(13);
      expression();
      if(obj != NIL)
         Gen(3,curlev - obj->vlev,obj->vadr);
   }
   else if(sym == pl0call){
      GetSym();
      if(sym == pl0ident){
          obj = find(id);
          if(obj->kind = Proc)
             Gen(4,curlev - obj->plev,obj->padr);
          else
             err(15);
           GetSym();
      }
      else
         err(14);
   }
   else if(sym == pl0begin){
      GetSym();
      while(1){
         statement();
         if(sym == pl0semicolon)
            GetSym();
         else if(sym == pl0end){
             GetSym();
             break;
         }
         else if(sym < pl0const)
             err(17);
         else{
            err(17); 
            break;
         }
      }
   }
   else if(sym == pl0if){
      GetSym();
      condition();
      if(sym == pl0then)
         GetSym();
      else
         err(16);
      L0 = Label();
      Gen(7,0,0);
      statement();
      fixup(L0);
    }
   else if(sym == pl0while ){
      L0 = Label();
      GetSym();
      condition();
      L1 = Label();
      Gen(7,0,0);
      if(sym == pl0do)
         GetSym();
      else
         err(18);
      statement();
      Gen(6,0,L0);
      fixup(L1);
    }
   else if(sym == pl0read ){
      GetSym();
      if(sym == pl0ident){
          obj = find(id);
          if(obj->kind == Var){
             Gen(1,0,14);
             Gen(3,curlev-obj->vlev,obj->vadr);
          }
          else
             err(12);
      }
      else
          err(14);
      GetSym();
   }
   else if(sym == pl0write){
      GetSym();
      expression();
      Gen(1,0,15);
   }
   test(pl0ident,19);
}

static ConstDeclaration()
{   
    ObjPtr obj;
    if(sym == pl0ident){
       GetSym();
       if(sym == pl0eql || sym == pl0becomes) {
         if(sym == pl0becomes)
             err(1);
         GetSym();
          if(sym == pl0number){
             obj = NewObj(Const);
             obj->val = num;
             GetSym();
           }
           else
              err(2);
       }
        else
            err(3);
    }
    else
       err(4);
}

VarDeclaration(adr)
unsigned int adr;
{
    ObjPtr obj;

    if(sym == pl0ident){
       obj = NewObj(Var);
       GetSym(); 
       obj->vlev = curlev;
       obj->vadr = adr;
       adr++;
       tempadr = adr;
    }
    else
        err(4);
}

static block()
{
   ObjPtr hd, obj;

   unsigned int adr,L0;

   curlev = curlev +1;
   adr = 3;

   hd = ( ObjPtr) malloc(sizeof(Object));
   hd->kind = Header;
   hd->next = NIL;
   hd->last = hd;
   hd->name = 0;
   hd->down = topScope;
   topScope = hd;
   L0 = Label();
   Gen(6,0,0);

   if(sym == pl0const){
      GetSym();
      while(1){
         ConstDeclaration();
          if(sym == pl0comma){ 
             GetSym();
          }
          else if(sym == pl0semicolon){
             GetSym();
             break;
          }
          else if(sym == pl0ident)
             err(5);
          else{
            err(5);
            break;
          }
      }
   }
   if(sym == pl0var){
       GetSym();
       while(1){
          VarDeclaration(adr); 
          adr = tempadr; 
          if(sym == pl0comma) {
             GetSym();
          }
          else if(sym == pl0semicolon){
             GetSym();
             break;
          }
          else if(sym == pl0ident)
             err(5);
          else{
             err(5);
             break;
          }
       }
   }
   while(sym == pl0procedure){
      GetSym();
      if(sym == pl0ident)
         GetSym();
      else
          err(4);
      obj = NewObj(Proc);
      obj->plev = curlev;
      obj->padr = Label();
      if(sym == pl0semicolon)
          GetSym();
      else
          err(5);
      block();
      if(sym == pl0semicolon)
         GetSym();
      else
          err(5);
    }
    fixup(L0);
    Gen(5,0,adr);
    statement();
    Gen(1,0,0);
    topScope = topScope->down;
    curlev = curlev-1;
}
parse()
{
   noerr = TRUE;
   topScope = NIL;
   curlev = 0;
   GetSym();
   block();
   if(sym != pl0period)
       err(9);
}

EndParser()
{
}

PL0Parser()
{
   undef = (ObjPtr)malloc(sizeof(Object));
   undef->name = 0;
   undef->next = NIL;
   undef->kind =Var ;
   undef->vlev =0; 
   undef->vadr = 0;
}

main(argc,argv)
    int argc;
    char *argv[];
{
   if(argc >1)
        source = fopen(argv[1], "r");
   else
        source = stdin;
   PL0Scanner();
   PL0Generator();
   PL0Parser(); 
   
   InitScanner(); 
   InitGenerator();

   parse();
   fclose(source);
   Interpret();
  
   CloseScanner();
   EndParser();
   EndGenerator();
   EndInterpreter();
   exit(0);
}

  







 


      
      
 




   


   
 
   
   

       
