#include<stdio.h>

typedef enum{
     pl0null,pl0odd,pl0times,pl0div,pl0plus,pl0minus,pl0eql,
     pl0neq,  pl0lss, pl0leq, pl0gtr, pl0geq, pl0comma, pl0rparen,  
     pl0then, pl0do, pl0lparen, pl0becomes, pl0number, pl0ident, 
     pl0semicolon, pl0end,pl0call, pl0if,pl0while,pl0begin,pl0read,
     pl0write,pl0const,pl0var,pl0procedure,pl0period,pl0eof
}Symbol;

#define maxCard   0177777
#define bufLen    1000

Symbol           sym;
unsigned  int    id;
unsigned  int    num;
FILE             *source;

static int        ch;
static unsigned int   id0,id1;
static struct{
     Symbol       sym;
     unsigned int ind;
}                 KeyTab[20];
static unsigned int K;
static char         buf[bufLen];
int                 line;

static Mark(message)
       char *message;
   {
      fprintf(stderr,"line %d : %s\n",line,message);
   }

static GetCh()
   {
      ch = getc(source);
      if(ch == '\n')
         line++;
   }

int Diff(u,v)
     unsigned int u,v;
   {   
      while(buf[u] != '\0' && buf[v] != '\0') {
         if(buf[u] != buf[v])
             break;
         u++;
         v++;
      }
     return (int)buf[u] - (int)buf[v];
}

KeepId()
{
   id = id1;
}

static Identifier()
{
   unsigned int k,l,m;
   int d;
  
   id1 = id;
   do{
      if(id1 < bufLen -1) {
         buf[id1] = ch;
         id1++;
      }
      GetCh();
   }while(('0' <= ch && ch <= '9')
            || ('A' <= ch && ch <= 'Z') || ('a' <= ch && ch <= 'z'));
   if(id1 < bufLen){
      buf[id1] = '\0';
      id1++;
   }
   k = 0;
   l = K;
   while(k < l){
      m = (k+l) /2;
      d = Diff(id,KeyTab[m].ind);
      if(d == 0) {
         sym = KeyTab[m].sym;
         return;
     }
     else if(d < 0)
        l = m;
     else
        k = m+1;
    }
    sym =  pl0ident;
}

static Number()
{
    unsigned int k,d;

    sym = pl0number;
    k = 0;
    do{
       d = ch - '0';
       if(d < 10 && (maxCard - d) /10 >=k)
           k = 10*k + d;
       else{
          Mark("number overflow");
          k = 0;
       }
       GetCh();
     }while('0' <= ch && ch <= '9');
     num = k;
}

static Comment()
{
    GetCh();
    do{
       while(ch != '*')
           GetCh();
        GetCh();
     }while(ch != ')');
      GetCh();
}

GetSym() 
{
    while(1) {
       if(ch <= ' '){
           if(ch == EOF){
               ch = ' ';
               break;
           }
           GetCh();
       }
       else if (ch >= 0177)
           GetCh();
       else 
           break;
      }
      switch(ch) {
         case' ' :        sym = pl0eof; ch = EOF; break;
         case'!' :        sym = pl0write; GetCh(); break;
         case'#' :        sym = pl0neq;   GetCh(); break;
         case'(' :        GetCh(); 
                         if(ch == '*'){
                              Comment();
                              GetSym();
                         }
                         else
                            sym = pl0lparen;
                         break;
         case')' :        sym = pl0rparen; GetCh(); break;       
         case'*' :        sym = pl0times;  GetCh(); break;
         case'+' :        sym = pl0plus;   GetCh(); break;        
         case',' :        sym = pl0comma;  GetCh(); break;
         case'-' :        sym = pl0minus;  GetCh(); break; 
         case'.' :        sym = pl0period; GetCh(); break;
         case'/' :        sym = pl0div;    GetCh(); break;
         case'0' : case'1' : case'2' : case'3' : case'4' :
         case'5' : case'6' : case'7' : case'8' : case'9' :    
                       Number(); break;
         case':' :        GetCh();
                         if(ch == '='){
                             GetCh();
                             sym = pl0becomes;
                         }
     			 else
                             sym = pl0null;
 			 break;
        case';':         sym = pl0semicolon;   GetCh();   break;
        case'<':         GetCh();
                         if(ch == '='){
                             GetCh();
                             sym = pl0leq;
                         }
                         else
          		    sym = pl0lss;
 			 break;
        case'=':         sym = pl0eql; GetCh();   break;    
        case'>':         GetCh();
                         if(ch == '='){
                             GetCh();
                             sym = pl0geq;
                         }
                         else
                            sym = pl0gtr;
                         break;
        case'?':      	 sym = pl0read;   GetCh();   break;
        case'A': case'B': case'C': case'D': case'E': case'F':
        case'G': case'H': case'I': case'J': case'K': case'L': case'M':
        case'N': case'O': case'P': case'Q': case'R': case'S':      
        case'T': case'U': case'V': case'W': case'X': case'Y': case'Z':
        case'a': case'b': case'c': case'd': case'e': case'f':
        case'g': case'h': case'i': case'j': case'k': case'l': case'm':
        case'n': case'o': case'p': case'q': case'r': case's': 
        case't': case'u': case'v': case'w': case'x': case'y': case'z':
                      Identifier();
                      break;
        default:      sym = pl0null; GetCh(); break;
     }
   }  
   
   InitScanner()
   {
       line = 1;
       ch = ' '; 
       if(id0 == 0)
          id0 = id;
       else
          id = id0;
   }

   CloseScanner()
   {
   }
   
   static EnterKW(sym,name)
       Symbol sym;
       char *name;
   {
      unsigned int l;

      KeyTab[K].sym = sym; 
      KeyTab[K].ind = id;
      K++;
      l = 0;
      while(name[l] != '\0') {
         buf[id] = name[l];
         id++;
         l++;
      }
      buf[id] = '\0';
      id++;
   }

   PL0Scanner()
   {
      K = 0;
      id = 0;
      id0 = 0;
      EnterKW(pl0begin,"BEGIN");
      EnterKW(pl0call, "CALL");
      EnterKW(pl0const,"CONST");
      EnterKW(pl0do, "DO");
      EnterKW(pl0end,"END");
      EnterKW(pl0if, "IF");
      EnterKW(pl0odd, "ODD");
      EnterKW(pl0procedure, "PROCEDURE");
      EnterKW(pl0then, "THEN");
      EnterKW(pl0var,"VAR");
      EnterKW(pl0while,"WHILE");
   }

  
   
      

  



